//uart.c
#include  "uart.h"
#include <iostr711.h>

// Init UART0 Interface
void InitUART0(void) {

   UART0_BR = 0x4E;                 //9600

   UART0_CR_bit.RUN=1;              //run boud rate generator
   UART0_CR_bit.RXENABLE=1;         //receiv enable
   UART0_CR_bit.STOPBITS=1;         //1 stop bit
   UART0_CR_bit.MODE=1;             //8 bit data

   IOPORT0_PC0_bit.no8=1;           //set UART function
   IOPORT0_PC1_bit.no8=0;
   IOPORT0_PC2_bit.no8=0;
   IOPORT0_PC0_bit.no9=1;
   IOPORT0_PC1_bit.no9=1;
   IOPORT0_PC2_bit.no9=1;
}

// Send char via UART10
void UART0_SendChar(unsigned char a) {

  while(UART0_SR_bit.TxEmpty == 0);
  UART0_TXBUFR = a;
}

// Send text via UART10
void UART0_SendTxt(char* a) {
  for(;*a;++a)
    UART0_SendChar(*a);
}


// Init UART1 Interface
void InitUART1(void) {

   UART1_BR = 0x4E;                 //9600

   UART1_CR_bit.RUN=1;              //run boud rate generator
   UART1_CR_bit.RXENABLE=1;         //receiv enable
   UART1_CR_bit.STOPBITS=1;         //1 stop bit
   UART1_CR_bit.MODE=1;             //8 bit data

   IOPORT0_PC0_bit.no10=1;           //set UART function
   IOPORT0_PC1_bit.no10=0;
   IOPORT0_PC2_bit.no10=0;
   IOPORT0_PC0_bit.no11=1;
   IOPORT0_PC1_bit.no11=1;
   IOPORT0_PC2_bit.no11=1;
}

// Send char via UART1
void UART1_SendChar(unsigned char a) {

  while(UART1_SR_bit.TxEmpty == 0);
  UART1_TXBUFR = a;
}

// Send text via UART1
void UART1_SendTxt(char* a) {
  for(;*a;++a)
    UART1_SendChar(*a);
}


// Init UART2 Interface
void InitUART2(void) {

   UART2_BR = 0x4E;                 //9600

   UART2_CR_bit.RUN=1;              //run boud rate generator
   UART2_CR_bit.RXENABLE=1;         //receiv enable
   UART2_CR_bit.STOPBITS=1;         //1 stop bit
   UART2_CR_bit.MODE=1;             //8 bit data

   IOPORT0_PC0_bit.no13=1;           //set UART function
   IOPORT0_PC1_bit.no13=0;
   IOPORT0_PC2_bit.no13=0;
   IOPORT0_PC0_bit.no14=1;
   IOPORT0_PC1_bit.no14=1;
   IOPORT0_PC2_bit.no14=1;
}

// Send char via UART2
void UART2_SendChar(unsigned char a) {

  while(UART2_SR_bit.TxEmpty == 0);
  UART2_TXBUFR = a;
}

// Send text via UART2
void UART2_SendTxt(char* a) {
  for(;*a;++a)
    UART2_SendChar(*a);
}


// Init UART3 Interface
void InitUART3(void) {

   UART3_BR = 0x4E;                 //9600

   UART3_CR_bit.RUN=1;              //run boud rate generator
   UART3_CR_bit.RXENABLE=1;         //receiv enable
   UART3_CR_bit.STOPBITS=1;         //1 stop bit
   UART3_CR_bit.MODE=1;             //8 bit data

   IOPORT0_PC0_bit.no0=1;           //set UART function
   IOPORT0_PC1_bit.no0=1;
   IOPORT0_PC2_bit.no0=1;
   IOPORT0_PC0_bit.no1=1;
   IOPORT0_PC1_bit.no1=0;
   IOPORT0_PC2_bit.no1=0;
}

// Send char via UART3
void UART3_SendChar(unsigned char a) {

  while(UART3_SR_bit.TxEmpty == 0);
  UART3_TXBUFR = a;
}

// Send text via UART3
void UART3_SendTxt(char* a) {
  for(;*a;++a)
    UART3_SendChar(*a);
}

